REM http://download.qt-project.org/official_releases/qt/4.8/4.8.5/qt-everywhere-opensource-src-4.8.5.tar.gz

set OSGEO4W_ROOT=C:\OSGeo4W64
set P=qt4
set V=4.8.5
set B=3

set R=..\..\..\x86_64\release\%P%
for %%i in (doc devel libs libs-debug) do (
	if not exist %R%\%P%-%%i mkdir %R%\%P%-%%i
	copy %%i.hint %R%\%P%-%%i\setup.hint
)

set pf=%ProgramFiles(x86)%
if "%pf%"=="" set pf=%ProgramFiles%
call "%pf%\Microsoft Visual Studio 10.0\VC\vcvarsall.bat" x64
echo on
path %pf%\Microsoft Visual Studio 10.0\Common7\IDE;%PATH%;%CD%;%OSGEO4W_ROOT%\bin;c:\cygwin\bin

set INCLUDE=%INCLUDE%;%OSGEO4W_ROOT%\include;%CD%\include
set LIB=%LIB%;%OSGEO4W_ROOT%\lib;%CD%\lib
set HERE=%CD%
set DESTDIR=%HERE%\install
set APPDIR=%DESTDIR%\apps\Qt4
cd ..
set SRC=%CD%

if not exist %HERE%\lib (
	mkdir %HERE%\lib
	copy %OSGEO4W_ROOT%\lib\sqlite3_i.lib %HERE%\lib\sqlite3.lib
	copy %OSGEO4W_ROOT%\lib\libtiff_i.lib %HERE%\lib\libtiff.lib
	copy %OSGEO4W_ROOT%\lib\jpeg_i.lib %HERE%\lib\libjpeg.lib
	copy %OSGEO4W_ROOT%\lib\zdll.lib %HERE%\lib\zlib.lib
	copy %OSGEO4W_ROOT%\lib\libpng16.lib %HERE%\lib\libpng.lib
)

if not exist %HERE%\patched (
	patch -p1 --binary <%HERE%\qt.diff
	if errorlevel 1 goto error
	touch %HERE%\patched
)

echo START: %DATE% %TIME%

if exist %HERE%\reconfigure goto reconfigure
if exist %SRC%\makefile goto build
goto configure

:reconfigure
del %HERE%\reconfigure
jom confclean
REM if errorlevel 1 goto error

:configure
echo CONFIGURE: %DATE% %TIME%
echo y>answer
echo y>>answer
set CONFIGURE=configure.exe ^
	-nomake examples ^
	-nomake demos ^
	-opensource ^
	-fast ^
	-iconv ^
	-prefix %DESTDIR% ^
	-bindir %DESTDIR%\bin ^
	-libdir %DESTDIR%\lib ^
	-docdir %APPDIR%\doc ^
	-importdir %APPDIR%\imports ^
	-headerdir %DESTDIR%\include\qt4 ^
	-datadir %APPDIR% ^
	-plugindir %APPDIR%\plugins ^
	-translationdir %APPDIR%\translations ^
	-platform win32-msvc2010 ^
	-debug-and-release ^
	-system-zlib ^
	-openssl ^
	-system-libpng ^
	-system-libjpeg ^
	-system-libtiff ^
	-system-sqlite ^
	-qt-sql-odbc ^
	-qt-sql-psql ^
	-plugin-sql-oci ^
	-plugin-sql-mysql ^
	-mp
%CONFIGURE%<answer
if errorlevel 1 goto error

:build
if not exist %APPDIR%\mkspecs (
	mkdir %APPDIR%\mkspecs
	xcopy /s /v /e %SRC%\mkspecs %APPDIR%\mkspecs
)

if exist %HERE%\clean (
	echo CLEAN: %DATE% %TIME%
	jom clean
	del %HERE%\clean
	if exist %HERE%\build-stamp del %HERE%\build-stamp
)

if exist %HERE%\build-stamp goto install

REM build it
echo MAKE: %DATE% %TIME%
jom /j8 /k
if errorlevel 1 jom /j8
if errorlevel 1 goto error

echo >%HERE%\build-stamp

:install
REM install it
echo INSTALL: %DATE% %TIME%
for %%i in (bin etc\ini etc\postinstall etc\preremove) do if not exist %DESTDIR%\%%i mkdir %DESTDIR%\%%i
copy %HERE%\qt.conf.tmpl %DESTDIR%\bin
copy %HERE%\qt4.bat %DESTDIR%\etc\ini
copy %HERE%\postinstall-libs.bat %DESTDIR%\etc\postinstall\qt4-libs.bat
copy %HERE%\postinstall-devel.bat %DESTDIR%\etc\postinstall\qt4-devel.bat
copy %HERE%\preremove.bat %DESTDIR%\etc\preremove\qt4-libs.bat
jom install
if errorlevel 1 goto error

:package
echo PACKAGE: %DATE% %TIME%

cd %DESTDIR%
move /y lib\*.pdb bin
move /y lib\*.dll bin
sed -e 's#%SRC:\=/%#@osgeo4w@/apps/Qt4#' %APPDIR%\mkspecs\default\qmake.conf >%APPDIR%\mkspecs\default\qmake.conf.tmpl
del %APPDIR%\mkspecs\default\qmake.conf

cd %HERE%

copy ..\LICENSE.FDL %R%\%P%-doc\%P%-doc-%V%-%B%.txt
tar --remove-files -C %DESTDIR% -cjf %R%\%P%-doc\%P%-doc-%V%-%B%.tar.bz2 ^
	apps/Qt4/doc
if errorlevel 1 goto error

copy ..\LICENSE.LGPL %R%\%P%-devel\%P%-devel-%V%-%B%.txt
tar --remove-files -C %DESTDIR% -cjf %R%\%P%-devel\%P%-devel-%V%-%B%.tar.bz2 ^
	etc/postinstall/qt4-devel.bat ^
	apps/Qt4/mkspecs ^
	apps/Qt4/phrasebooks ^
	apps/Qt4/plugins/designer ^
	apps/Qt4/translations/assistant_cs.qm ^
	apps/Qt4/translations/assistant_da.qm ^
	apps/Qt4/translations/assistant_de.qm ^
	apps/Qt4/translations/assistant_fr.qm ^
	apps/Qt4/translations/assistant_hu.qm ^
	apps/Qt4/translations/assistant_ja.qm ^
	apps/Qt4/translations/assistant_ko.qm ^
	apps/Qt4/translations/assistant_pl.qm ^
	apps/Qt4/translations/assistant_ru.qm ^
	apps/Qt4/translations/assistant_sl.qm ^
	apps/Qt4/translations/assistant_uk.qm ^
	apps/Qt4/translations/assistant_zh_CN.qm ^
	apps/Qt4/translations/assistant_zh_TW.qm ^
	apps/Qt4/translations/designer_cs.qm ^
	apps/Qt4/translations/designer_de.qm ^
	apps/Qt4/translations/designer_fr.qm ^
	apps/Qt4/translations/designer_hu.qm ^
	apps/Qt4/translations/designer_ja.qm ^
	apps/Qt4/translations/designer_ko.qm ^
	apps/Qt4/translations/designer_pl.qm ^
	apps/Qt4/translations/designer_ru.qm ^
	apps/Qt4/translations/designer_sl.qm ^
	apps/Qt4/translations/designer_uk.qm ^
	apps/Qt4/translations/designer_zh_CN.qm ^
	apps/Qt4/translations/designer_zh_TW.qm ^
	apps/Qt4/translations/linguist_cs.qm ^
	apps/Qt4/translations/linguist_de.qm ^
	apps/Qt4/translations/linguist_fr.qm ^
	apps/Qt4/translations/linguist_hu.qm ^
	apps/Qt4/translations/linguist_ja.qm ^
	apps/Qt4/translations/linguist_ko.qm ^
	apps/Qt4/translations/linguist_pl.qm ^
	apps/Qt4/translations/linguist_ru.qm ^
	apps/Qt4/translations/linguist_sl.qm ^
	apps/Qt4/translations/linguist_uk.qm ^
	apps/Qt4/translations/linguist_zh_CN.qm ^
	apps/Qt4/translations/linguist_zh_TW.qm ^
	apps/Qt4/translations/qtconfig_hu.qm ^
	apps/Qt4/translations/qtconfig_ja.qm ^
	apps/Qt4/translations/qtconfig_ko.qm ^
	apps/Qt4/translations/qtconfig_pl.qm ^
	apps/Qt4/translations/qtconfig_ru.qm ^
	apps/Qt4/translations/qtconfig_sl.qm ^
	apps/Qt4/translations/qtconfig_uk.qm ^
	apps/Qt4/translations/qtconfig_zh_CN.qm ^
	apps/Qt4/translations/qtconfig_zh_TW.qm ^
	apps/Qt4/translations/qvfb_hu.qm ^
	apps/Qt4/translations/qvfb_ja.qm ^
	apps/Qt4/translations/qvfb_ko.qm ^
	apps/Qt4/translations/qvfb_pl.qm ^
	apps/Qt4/translations/qvfb_ru.qm ^
	apps/Qt4/translations/qvfb_sl.qm ^
	apps/Qt4/translations/qvfb_uk.qm ^
	apps/Qt4/translations/qvfb_zh_CN.qm ^
	apps/Qt4/translations/qvfb_zh_TW.qm ^
	apps/Qt4/q3porting.xml ^
	bin/qmlplugindump.exe ^
	bin/assistant.exe ^
	bin/designer.exe ^
	bin/idc.exe ^
	bin/lconvert.exe ^
	bin/linguist.exe ^
	bin/lrelease.exe ^
	bin/lupdate.exe ^
	bin/moc.exe ^
	bin/pixeltool.exe ^
	bin/qcollectiongenerator.exe ^
	bin/qdoc3.exe ^
	bin/qhelpconverter.exe ^
	bin/qhelpgenerator.exe ^
	bin/qmake.exe ^
	bin/qmlviewer.exe ^
	bin/qt3to4.exe ^
	bin/qttracereplay.exe ^
	bin/rcc.exe ^
	bin/uic.exe ^
	bin/uic3.exe ^
	bin/xmlpatterns.exe ^
	bin/xmlpatternsvalidator.exe ^
	include/qt4 ^
	lib/Qt3Support.prl ^
	lib/Qt3Support4.lib ^
	lib/QtCLucene.prl ^
	lib/QtCLucene4.lib ^
	lib/QtCore.prl ^
	lib/QtCore4.lib ^
	lib/QtDeclarative.prl ^
	lib/QtDeclarative4.lib ^
	lib/QtDesigner.prl ^
	lib/QtDesigner4.lib ^
	lib/QtDesignerComponents.prl ^
	lib/QtDesignerComponents4.lib ^
	lib/QtGui.prl ^
	lib/QtGui4.lib ^
	lib/QtHelp.prl ^
	lib/QtHelp4.lib ^
	lib/QtNetwork.prl ^
	lib/QtNetwork4.lib ^
	lib/QtOpenGL.prl ^
	lib/QtOpenGL4.lib ^
	lib/QtScript.prl ^
	lib/QtScript4.lib ^
	lib/QtScriptTools.prl ^
	lib/QtScriptTools4.lib ^
	lib/QtSql.prl ^
	lib/QtSql4.lib ^
	lib/QtSvg.prl ^
	lib/QtSvg4.lib ^
	lib/QtTest.prl ^
	lib/QtTest4.lib ^
	lib/QtUiTools.lib ^
	lib/QtUiTools.prl ^
	lib/QtWebKit.prl ^
	lib/QtWebKit4.lib ^
	lib/QtXml.prl ^
	lib/QtXml4.lib ^
	lib/QtXmlPatterns.prl ^
	lib/QtXmlPatterns4.lib ^
	lib/phonon.prl ^
	lib/phonon4.lib ^
	lib/qaxcontainer.lib ^
	lib/qaxcontainer.prl ^
	lib/qaxserver.lib ^
	lib/qaxserver.prl ^
	lib/qtmain.lib ^
	lib/qtmain.prl ^
	lib/qtmultimedia.prl ^
	lib/qtmultimedia4.lib
if errorlevel 1 goto error

copy ..\LICENSE.LGPL %R%\%P%-libs-debug\%P%-libs-debug-%V%-%B%.txt
tar --remove-files -C %DESTDIR% -cjf %R%\qt4-libs-debug\%P%-libs-debug-%V%-%B%.tar.bz2 ^
	-T %HERE%\libs.debug
	
copy ..\LICENSE.LGPL %R%\%P%-libs\%P%-libs-%V%-%B%.txt
tar -C .. -cjf %R%\%P%-libs\%P%-libs-%V%-%B%-src.tar.bz2 ^
	osgeo4w/devel.hint ^
	osgeo4w/doc.hint ^
	osgeo4w/jom.exe ^
	osgeo4w/libs.debug ^
	osgeo4w/libs.hint ^
	osgeo4w/libs-debug.hint ^
	osgeo4w/package64.cmd ^
	osgeo4w/postinstall-devel.bat ^
	osgeo4w/postinstall-libs.bat ^
	osgeo4w/preremove.bat ^
	osgeo4w/qt.conf.tmpl ^
	osgeo4w/qt4.bat ^
	osgeo4w/qt.diff
if errorlevel 1 goto error

tar --remove-files -C %DESTDIR% -cjf %R%\%P%-libs\%P%-libs-%V%-%B%.tar.bz2 ^
	--exclude-from %HERE%\libs.debug ^
	apps/Qt4/plugins/codecs ^
	apps/Qt4/plugins/iconengines ^
	apps/Qt4/plugins/imageformats ^
	apps/Qt4/plugins/phonon_backend ^
	apps/Qt4/plugins/sqldrivers ^
	apps/Qt4/plugins/qmltooling ^
	apps/Qt4/translations/qt_ar.qm ^
	apps/Qt4/translations/qt_cs.qm ^
	apps/Qt4/translations/qt_da.qm ^
	apps/Qt4/translations/qt_de.qm ^
	apps/Qt4/translations/qt_es.qm ^
	apps/Qt4/translations/qt_fa.qm ^
	apps/Qt4/translations/qt_fr.qm ^
	apps/Qt4/translations/qt_gl.qm ^
	apps/Qt4/translations/qt_he.qm ^
	apps/Qt4/translations/qt_help_cs.qm ^
	apps/Qt4/translations/qt_help_da.qm ^
	apps/Qt4/translations/qt_help_de.qm ^
	apps/Qt4/translations/qt_help_fr.qm ^
	apps/Qt4/translations/qt_help_gl.qm ^
	apps/Qt4/translations/qt_help_hu.qm ^
	apps/Qt4/translations/qt_help_ja.qm ^
	apps/Qt4/translations/qt_help_ko.qm ^
	apps/Qt4/translations/qt_help_pl.qm ^
	apps/Qt4/translations/qt_help_ru.qm ^
	apps/Qt4/translations/qt_help_sl.qm ^
	apps/Qt4/translations/qt_help_uk.qm ^
	apps/Qt4/translations/qt_help_zh_CN.qm ^
	apps/Qt4/translations/qt_help_zh_TW.qm ^
	apps/Qt4/translations/qt_hu.qm ^
	apps/Qt4/translations/qt_ja.qm ^
	apps/Qt4/translations/qt_ko.qm ^
	apps/Qt4/translations/qt_lt.qm ^
	apps/Qt4/translations/qt_pl.qm ^
	apps/Qt4/translations/qt_pt.qm ^
	apps/Qt4/translations/qt_ru.qm ^
	apps/Qt4/translations/qt_sk.qm ^
	apps/Qt4/translations/qt_sl.qm ^
	apps/Qt4/translations/qt_sv.qm ^
	apps/Qt4/translations/qt_uk.qm ^
	apps/Qt4/translations/qt_zh_CN.qm ^
	apps/Qt4/translations/qt_zh_TW.qm ^
	apps/Qt4/plugins/accessible ^
	apps/Qt4/plugins/bearer ^
	apps/Qt4/plugins/graphicssystems ^
	apps/Qt4/imports ^
	bin/Qt3Support4.dll ^
	bin/qtmultimedia4.dll ^
	bin/QtCLucene4.dll ^
	bin/QtCore4.dll ^
	bin/QtDesigner4.dll ^
	bin/QtDesignerComponents4.dll ^
	bin/QtDeclarative4.dll ^
	bin/QtGui4.dll ^
	bin/QtHelp4.dll ^
	bin/QtNetwork4.dll ^
	bin/QtOpenGL4.dll ^
	bin/QtScript4.dll ^
	bin/QtScriptTools4.dll ^
	bin/QtSql4.dll ^
	bin/QtSvg4.dll ^
	bin/QtTest4.dll ^
	bin/QtWebKit4.dll ^
	bin/QtXml4.dll ^
	bin/QtXmlPatterns4.dll ^
	bin/phonon4.dll ^
	bin/qt.conf.tmpl ^
	etc/ini/qt4.bat ^
	etc/postinstall/qt4-libs.bat ^
	etc/preremove/qt4-libs.bat
if errorlevel 1 goto error

goto end

:error
echo ERROR %ERRORLEVEL%: %DATE% %TIME%

:end
echo END: %DATE% %TIME%

:error

